# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

# We don't really need ExtUtils::MakeMaker ≥ 6.64
%global old_eumm %(perl -MExtUtils::MakeMaker -e 'print (($ExtUtils::MakeMaker::VERSION < 6.64) ? 1 : 0);' 2>/dev/null || echo 0)

# We need to patch the test suite if we have an old version of Test::More
%global old_test_more %(perl -MTest::More -e 'print (($Test::More::VERSION < 0.95) ? 1 : 0);' 2>/dev/null || echo 0)

Summary:	Check if Makefile.PL has the right pre-requisites
Name:		perl-Test-Prereq
Version:	1.039
Release:	3.%{__distinit}%{__distvers}
License:	Artistic 2.0
Group:		Development/Libraries
URL:		http://search.cpan.org/dist/Test-Prereq/
Source0:	http://search.cpan.org/CPAN/authors/id/B/BD/BDFOY/Test-Prereq-%{version}.tar.gz
Source1:	CPAN.conf
Patch10:	Test-Prereq-1.039-old-eumm.patch
Patch11:	Test-Prereq-1.038-tm095.patch
Patch12:	Test-Prereq-1.039-CoreList.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
BuildArch:	noarch
# Module Build
BuildRequires:	findutils
BuildRequires:	make
BuildRequires:	perl
%if 0%{?fedora} > 20 || 0%{?rhel} > 7
BuildRequires:	perl-generators
%endif
# Module Runtime
BuildRequires:	perl(base)
BuildRequires:	perl(Carp)
BuildRequires:	perl(CPAN)
BuildRequires:	perl(Exporter)
BuildRequires:	perl(ExtUtils::MakeMaker) >= 6.17
BuildRequires:	perl(File::Find)
BuildRequires:	perl(LWP::UserAgent)
BuildRequires:	perl(Module::Build)
BuildRequires:	perl(Module::CoreList)
BuildRequires:	perl(Module::Info)
BuildRequires:	perl(strict)
BuildRequires:	perl(Test::Builder)
BuildRequires:	perl(Test::More)
BuildRequires:	perl(utf8)
BuildRequires:	perl(vars)
BuildRequires:	perl(warnings)
# Test Suite
BuildRequires:	perl(Cwd)
BuildRequires:	perl(lib)
BuildRequires:	perl(Test::Builder::Tester)
# Optional Tests
BuildRequires:	perl(Test::Manifest) >= 1.21
BuildRequires:	perl(Test::Pod) >= 1.00
BuildRequires:	perl(Test::Pod::Coverage)
# Runtime
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
Requires:	perl(CPAN)
Requires:	perl(LWP::UserAgent)

%description
Test::Prereq - check if Makefile.PL has the right pre-requisites.

%prep
%setup -q -n Test-Prereq-%{version}

# We don't really need ExtUtils::MakeMaker ≥ 6.64
%if %{old_eumm}
%patch10
%endif

# We need to patch the test suite if we have an old version of Test::More
%if %{old_test_more}
%patch11
%endif

# Workaround for Module::CoreList issues with Perl 5.8 and 5.20.3
%patch12

# Set up CPAN
mkdir -p .cpan/{CPAN,sources,sources/authors,sources/modules}
perl -p -e 's|BUILDDIR|'$(pwd)'|;' %{SOURCE1} > .cpan/CPAN/MyConfig.pm
if [ -n "$http_proxy" ]; then
	perl -pi -e "s|HTTP_PROXY|$http_proxy|;" .cpan/CPAN/MyConfig.pm
else
	perl -pi -e "s|HTTP_PROXY||;" .cpan/CPAN/MyConfig.pm
fi
if [ -n "$ftp_proxy" ]; then
	perl -pi -e "s|FTP_PROXY|$ftp_proxy|;" .cpan/CPAN/MyConfig.pm
else
	perl -pi -e "s|FTP_PROXY||;" .cpan/CPAN/MyConfig.pm
fi
if [ -n "$no_proxy" ]; then
	perl -pi -e "s|NO_PROXY|$no_proxy|;" .cpan/CPAN/MyConfig.pm
else
	perl -pi -e "s|NO_PROXY||;" .cpan/CPAN/MyConfig.pm
fi

%build
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
rm -rf %{buildroot}
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -delete
%{_fixperms} %{buildroot}

# If we have an old ExtUtils::MakeMaker, README.pod could get installed, which we don't want
rm -f %{buildroot}%{_mandir}/man3/Test::README.3pm
rm -f %{buildroot}%{perl_vendorlib}/Test/README.pod

%check
make FULLPERL="perl -I$(pwd)/.cpan" test

%clean
rm -rf %{buildroot}

%files
%if 0%{?_licensedir:1}
%license LICENSE
%else
%doc LICENSE
%endif
%doc Changes README.pod
%{perl_vendorlib}/Test/
%{_mandir}/man3/Test::Prereq.3*
%{_mandir}/man3/Test::Prereq::Build.3*

%changelog
* Tue Aug  2 2016 Paul Howarth <paul@city-fan.org> - 1.039-3
- Update CoreList patch to fix build on Perl 5.20.3
- BR: perl-generators where available
- Avoid installing README.pod with old ExtUtils::MakeMaker versions
- Simplify find command using -delete

* Sun Aug  9 2015 Paul Howarth <paul@city-fan.org> - 1.039-1
- Update to 1.039
  - Adjust default list for v5.20, kicking out Module::Build (Debian #789479,
    CPAN RT#105398)
  - Don't install README.pod
- Drop upstreamed patches
- License is now Artistic 2.0
- Update patches as needed

* Mon Jun 22 2015 Paul Howarth <paul@city-fan.org> - 1.038-4
- Incorporate changes from upstream dev release 1.038_05
  - Handle TEST_REQUIRES
  - Fixes for v5.8, which doesn't include Module::Build
  - Fixup for CONFIGURE_REQUIRES (GitHub Issue #2)
- Add workaround for FTBFS in Perl 5.22 (CPAN RT#105398)
- Add workaround for Module::CoreList issues with Perl 5.8
- Classify buildreqs by usage

* Mon Sep  1 2014 Paul Howarth <paul@city-fan.org> - 1.038-2
- Drop %%defattr, redundant since rpm 4.4
- Use %%license where possible

* Fri Jan  3 2014 Paul Howarth <paul@city-fan.org> - 1.038-1
- Update to 1.038
  - Use Makefile.PL instead of Build.PL since Module::Build is likely to be
    deprecated
  - Fix up Pod encoding issues
- Add patches to support building with old versions of ExtUtils::MakeMaker and
  Test::More

* Mon Jul  2 2012 Paul Howarth <paul@city-fan.org> - 1.037-9
- BR: perl(base), perl(Carp), perl(Cwd), perl(Exporter), perl(lib),
  perl(Test::Builder) and perl(Test::More)
- Don't need to remove empty directories from the buildroot
- Drop support for old distributions prior to FC-3:
  - Don't need to define %%{perl_vendorlib}
  - Use DESTDIR rather than PERL_INSTALL_ROOT

* Thu Jul  7 2011 Paul Howarth <paul@city-fan.org> - 1.037-7
- Rebuild for perl 5.14.1 in Rawhide
- Nobody else likes macros for commands
- Fix dist tag for CentOS 6 and Scientific Linux

* Thu Jun 24 2010 Paul Howarth <paul@city-fan.org> - 1.037-4
- Rebuild for perl 5.12.1 in Rawhide

* Fri May 28 2010 Paul Howarth <paul@city-fan.org> - 1.037-3
- Fix dist tag for RHEL-6 Beta

* Wed Mar  3 2010 Paul Howarth <paul@city-fan.org> - 1.037-2
- Dist tag for Rawhide no longer needs special-casing
- Use %%{_fixperms} macro instead of our own %%{__chmod} incantation
- Buildreq perl(LWP::UserAgent) as preferred download method for CPAN
- Update CPAN.conf to work with current perl(CPAN)

* Mon Jun  1 2009 Paul Howarth <paul@city-fan.org> - 1.037-1
- Update to 1.037 (qualify calls to find() so Module::Install doesn't intercept
  them - RT #46335)
- Update to SLES-compatible dist tag macros

* Thu Jan 22 2009 Paul Howarth <paul@city-fan.org> - 1.036-1
- Update to 1.036

* Mon Aug  4 2008 Paul Howarth <paul@city-fan.org> - 1.034-1
- Update to 1.034
- Clarify license as GPL version 1 or later, or Artistic (i.e. same as perl)
- Tweak dist tag macros to work on current Rawhide with three-part releasenum

* Mon Mar 19 2007 Paul Howarth <paul@city-fan.org> - 1.033-1
- Update to 1.033
- Fix dist tag for Fedora 7 onwards
- BuildRequire perl(ExtUtils::MakeMaker)

* Wed Jan 10 2007 Paul Howarth <paul@city-fan.org> - 1.032-1
- Update to 1.032
- Fix argument order for find with -depth
- Include LICENSE file
- Add buildreqs perl(Test::Pod) and perl(Test::Pod::Coverage)

* Fri Sep  1 2006 Paul Howarth <paul@city-fan.org> - 1.031-2
- Fix distribution tags for development releases
- Provide CPAN config so that get_from_prereqs test doesn't hang
- Add buildreq perl(CPAN)

* Thu May 18 2006 Paul Howarth <paul@city-fan.org> - 1.031-1
- Update to 1.031
- Update distribution-detection code
- Define %%{__id_u} in a more portable way

* Fri Jan 13 2006 Paul Howarth <paul@city-fan.org> - 1.030-1
- Update to 1.030

* Sat Dec 31 2005 Paul Howarth <paul@city-fan.org> - 1.029-1
- Update to 1.029
- Simplify distribution-detection
- Clarify spec by removing __perl_version and __perl_package macros
- Unconditionally remove buildroot in %%clean and %%install
- Don't use macros in build-time command paths, hardcode them instead
- Fix directory ownership
- Use search.cpan.org URLs

* Tue Jul 26 2005 Paul Howarth <paul@city-fan.org> - 1.028-1
- Update to 1.028

* Thu Jul  7 2005 Paul Howarth <paul@city-fan.org> - 1.027-2
- Rewrite spec file in (mainly) Fedora Extras style
- Include full URL for source
- Fix URL
- Use MODULE_COMPAT dependency style and remove explicit perl dependency
- Remove MANIFEST from %%doc

* Wed Mar  9 2005 Paul Howarth <paul@city-fan.org> - 1.027-1
- Update to 1.027
- Update URL

* Wed Oct 27 2004 Paul Howarth <paul@city-fan.org> - 1.025-1
- Update to 1.025
- Tidy up spec file
- Add BuildRequires: perl-Test-Manifest to get working set of tests

* Mon May 10 2004 Paul Howarth <paul@city-fan.org> - 0.23-1
- Initial build
